Index: /trunk/gsdl/perllib/plugins/BasPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/BasPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/BasPlug.pm	(revision 10218)
@@ -53,4 +53,7 @@
 use gsprintf 'gsprintf';
 use printusage;
+#$%^
+use parse2;
+
 
 use GISBasPlug;
@@ -59,7 +62,5 @@
 
 my $unicode_list =
-    [ { 'name' => "auto",
-	'desc' => "{BasPlug.input_encoding.auto}" },
-      { 'name' => "ascii",
+    [ { 'name' => "ascii",
 	'desc' => "{BasPlug.input_encoding.ascii}" },
       { 'name' => "utf8",
@@ -68,4 +69,8 @@
 	'desc' => "{BasPlug.input_encoding.unicode}" } ];
 
+my $auto_unicode_list = 
+    [ { 'name' => "auto",
+	'desc' => "{BasPlug.input_encoding.auto}" } ];
+
 my $arguments =
     [ { 'name' => "process_exp",
@@ -90,5 +95,5 @@
 	'desc' => "{BasPlug.input_encoding}",
 	'type' => "enum",
-	'list' => $unicode_list,
+	'list' => $auto_unicode_list,
 	'reqd' => "no" ,
 	'deft' => "auto" } ,
@@ -107,4 +112,5 @@
 	'type' => "language",
 	'deft' => "en",
+	'char_length' => "2",
 	'reqd' => "no" },
       { 'name' => "extract_acronyms",
@@ -141,9 +147,11 @@
 	'type' => "int",
 	'deft' => (localtime)[5]+1900,
+	'char_length' => "4",
+	#'range' => "2,100",
 	'reqd' => "no"},
       { 'name' => "maximum_century",
 	'desc' => "{BasPlug.maximum_century}",
 	'type' => "string",
-	'deft' => "",
+	'deft' => "-1",
 	'reqd' => "no" },
       { 'name' => "no_bibliography",
@@ -154,5 +162,30 @@
 	'desc' => "{BasPlug.no_cover_image}",
 	'type' => "flag",
-	'reqd' => "no" } ];
+	'reqd' => "no" },
+      { 'name' => "extract_keyphrases",
+	'desc' => "{BasPlug.extract_keyphrases}",
+	'type' => "flag",
+	'reqd' => "no",
+	'hiddengli' => "yes" },
+      { 'name' => "extract_keyphrase_options",
+	'desc' => "{BasPlug.extract_keyphrase_options}",
+	'type' => "string",
+	'reqd' => "no",
+	'hiddengli' => "yes" },
+      { 'name' => "separate_cjk",
+	'desc' => "{BasPlug.separate_cjk}",
+	'type' => "flag",
+	'reqd' => "no",
+	'hiddengli' => "yes" },
+      { 'name' => "smart_block",
+	'desc' => "{BasPlug.smart_block}",
+	'type' => "flag",
+	'reqd' => "no",
+	'hiddengli' => "yes" },
+      { 'name' => "new_extract_email",
+	'desc' => "",
+	'type' => "flag",
+	'reqd' => "no",
+	'hiddengli' => "yes" } ];
 
 my $gis_arguments = 
@@ -238,5 +271,4 @@
 {
     my $self = shift(@_);
-
     # Print the usage message for a plugin (recursively)
     my $descoffset = $self->determine_description_offset(0);
@@ -317,23 +349,45 @@
 
 sub new {
+    # Set Encodings to the list!!
+
+    my $e = $encodings::encodings;
+    foreach my $enc (sort {$e->{$a}->{'name'} cmp $e->{$b}->{'name'}} keys (%$e)) 
+    {
+	my $hashEncode =
+	    {'name' => $enc,
+	     'desc' => $e->{$enc}->{'name'}};
+
+	push(@{$unicode_list},$hashEncode);
+    }
+
+    push(@{$auto_unicode_list},@{$unicode_list});
+
+    # Start the BasPlug Constructor
     my $class = shift (@_);
-    my $plugin_name = shift (@_);
-    my $self = {};
-    $self->{'plugin_type'} = "BasPlug";
+    my ($pluginlist,$args,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+    my $plugin_name = (defined $pluginlist->[0]) ? $pluginlist->[0] : $class;
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
 
     if (GISBasPlug::has_mapdata()) {
 	push(@$arguments,@$gis_arguments);
     }
-
-    my $enc = "^(";
-    map {$enc .= "$_|";} keys %$encodings::encodings;
-    my $denc = $enc . "ascii|utf8|unicode)\$";
-    $enc .= "ascii|utf8|unicode|auto)\$";
-    
+    
+    my $self = {};
+    if(!parse2::parse($args,$hashArgOptLists->{"ArgList"},$self))
+    {
+	my $classTempClass = bless $self, $class;
+	&gsprintf(STDERR, "\n{BasPlug.bad_general_option}\n", $plugin_name);
+	$classTempClass->print_txt_usage("");  # Use default resource bundle
+	die "\n";
+    }
+
+    # else parsing was successful.
+
+    $self->{'plugin_type'} = $plugin_name;
     $self->{'outhandle'} = STDERR;
-    my $year = (localtime)[5]+1900;
-
     $self->{'textcat'} = new textcat();
-
     $self->{'num_processed'} = 0;
     $self->{'num_not_processed'} = 0;
@@ -341,43 +395,8 @@
     $self->{'num_archives'} = 0;
     $self->{'cover_image'} = 1; # cover image is on by default
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    $self->{'option_list'} = [ $options ];
-    
-    my $no_cover_image = 0;
-    # general options available to all plugins
-    if (!parsargv::parse(\@_,
-			 q^process_exp/.*/^, \$self->{'process_exp'},
-			 q^block_exp/.*/^, \$self->{'block_exp'},
-			 q^associate_ext/.*/^, \$self->{'associate_ext'},
-			 q^extract_language^, \$self->{'extract_language'},
-			 q^extract_acronyms^, \$self->{'extract_acronyms'}, 
-			 q^extract_keyphrases^, \$self->{'kea'}, #with extra options (UNDOCUMENTED)
-			 q^extract_keyphrase_options/.*/^, \$self->{'kea_options'}, #no extra options (UNDOCUMENTED)
-			 qq^input_encoding/$enc/auto^, \$self->{'input_encoding'},
-			 qq^default_encoding/$denc/utf8^, \$self->{'default_encoding'},
-			 q^extract_email^, \$self->{'extract_email'},
-			 q^extract_placenames^, \$self->{'extract_placenames'}, 
-			 q^gazetteer/.*/^, \$self->{'gazetteer'},
-			 q^place_list^, \$self->{'place_list'}, 
-			 q^markup_acronyms^, \$self->{'markup_acronyms'},
-			 q^default_language/.{2}/en^, \$self->{'default_language'},
-			 q^first/.*/^, \$self->{'first'},
-			 q^extract_historical_years^, \$self->{'date_extract'},
-			 qq^maximum_year/\\d{4}/$year^, \$self->{'max_year'},
-			 q^no_bibliography^, \$self->{'no_biblio'},
-			 qq^maximum_century/-?\\d{1,2}( ?B\\.C\\.E\\.)?/-1^, \$self->{'max_century'},
-			 q^no_cover_image^, \$no_cover_image,
-			 q^separate_cjk^, \$self->{'separate_cjk'},
-			 q^smart_block^, \$self->{'smart_block'},
-			 q^smart_block_BN^, \$self->{'smart_block_BN'},	
-			 "allow_extra_options")) {
-
-	gsprintf(STDERR, "\n{BasPlug.bad_general_option}\n", $plugin_name);
-    	bless $self, $class;
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-
+    $self->{'cover_image'} = 0 if ($self->{'no_cover_image'});
+    $self->{'file_blocks'} = {};
+    $self->{'option_list'} = $hashArgOptLists->{"OptList"};
+    
     my $associate_ext = $self->{'associate_ext'};
     if ((defined $associate_ext) && ($associate_ext ne "")) {
@@ -395,13 +414,11 @@
     $self->{'file_blocks'} = {};
 
-    $self->{'cover_image'} = 0 if ($no_cover_image);
-
     if ($self->{'extract_placenames'}) {
 
 	my $outhandle = $self->{'outhandle'};
-
+	
 	my $places_ref 
 	    = GISBasPlug::loadGISDatabase($outhandle,$self->{'gazetteer'});
-
+	
 	if (!defined $places_ref) {
 	    print $outhandle "Warning: Error loading mapdata gazetteer \"$self->{'gazetteer'}\"\n";
@@ -414,4 +431,5 @@
     }	
     return bless $self, $class;
+    
 }
 
@@ -1121,8 +1139,26 @@
     @email = sort @email;
     
-    my @email2 = ();
+#    if($self->{"new_extract_email"} == 0)
+#    {
+#    my @email2 = ();
+#    foreach my $address (@email) 
+#   {
+#	if (!(join(" ",@email2) =~ m/(^| )$address( |$)/ )) 
+#	    {
+#		push @email2, $address;
+#		$doc_obj->add_utf8_metadata ($thissection, "emailAddress", $address);
+#		# print $outhandle "  extracting $address\n" 
+#		&gsprintf($outhandle, "  {BasPlug.extracting} $address\n")
+#		    if ($self->{'verbosity'} > 3);
+#	    }
+#	}
+#    }
+#    else
+#    {
+    my $hashExistMail = {};
     foreach my $address (@email) {
-	if (!(join(" ",@email2) =~ m/$address/ )) {
-	    push @email2, $address;
+	if (!(defined $hashExistMail->{$address}))
+	{
+	    $hashExistMail->{$address} = 1;
 	    $doc_obj->add_utf8_metadata ($thissection, "emailAddress", $address);
 	    gsprintf($outhandle, "  {BasPlug.extracting} $address\n")
@@ -1157,6 +1193,6 @@
     } 
 
-    # adding kea keyphrases
-    if ($self->{'kea'}) {
+    #adding kea keyphrases
+    if ($self->{'extract_keyphrases'}) {  
 	
 	my $thissection = $doc_obj->get_top_section();
@@ -1171,11 +1207,10 @@
 	} 
        
-	if ($self->{'kea_options'}) {
-	    #if kea options flag is set, call Kea with specified options 
-	    $list = &Kea::extract_KeyPhrases ($text, $self->{'kea_options'}); 
-	} else { 
-	    #otherwise call Kea with no options
+	if($self->{'extract_keyphrase_options'}) { #if kea options flag is set, call Kea with specified options 
+	    $list = &Kea::extract_KeyPhrases ($text, $self->{'extract_keyphrase_options'}); 
+	} else { #otherwise call Kea with no options
 	    $list = &Kea::extract_KeyPhrases ($text); 
 	}
+	 
 	if ($list){
 	    # if a list of kea keyphrases was returned (ie not empty)
@@ -1227,14 +1262,14 @@
     }
 
-    if($self->{'date_extract'}) {
+    if($self->{'extract_historical_years'}) {
 	my $thissection = $doc_obj->get_top_section();
 	while (defined $thissection) {
-	    
+
 	    my $text = $doc_obj->get_text($thissection);
 	    &DateExtract::get_date_metadata($text, $doc_obj, 
 					    $thissection, 
-					    $self->{'no_biblio'}, 
-					    $self->{'max_year'}, 
-					    $self->{'max_century'});
+					    $self->{'no_bibliography'}, 
+					    $self->{'maximum_year'}, 
+					    $self->{'maximum_century'});
 	    $thissection = $doc_obj->get_next_section ($thissection);
 	}
Index: /trunk/gsdl/perllib/plugins/BibTexPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/BibTexPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/BibTexPlug.pm	(revision 10218)
@@ -81,10 +81,13 @@
 }
 sub new {
-    my $class = shift (@_);
-    my $self = new SplitPlug ($class, @_);
-    $self->{'plugin_type'} = "BibTexPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new SplitPlug($pluginlist,$inputargs,$hashArgOptLists): new SplitPlug($pluginlist,$inputargs);
+
     return bless $self, $class;
 }
Index: /trunk/gsdl/perllib/plugins/BookPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/BookPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/BookPlug.pm	(revision 10218)
@@ -79,11 +79,13 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ("BookPlug", @_);
-    $self->{'plugin_type'} = "BookPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-    
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
+
     return bless $self, $class;
 }
Index: /trunk/gsdl/perllib/plugins/ConvertToPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/ConvertToPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/ConvertToPlug.pm	(revision 10218)
@@ -65,5 +65,15 @@
 	'desc' => "{ConvertToPlug.use_strings}",
 	'type' => "flag",
-	'reqd' => "no" } ];
+	'reqd' => "no" },
+      { 'name' => "extract_keyphrases",
+	'desc' => "{BasPlug.extract_keyphrases}",
+	'type' => "flag",
+	'reqd' => "no",
+	'hiddengli' => "yes" },
+      { 'name' => "extract_keyphrase_options",
+	'desc' => "{BasPlug.extract_keyphrase_options}",
+	'type' => "string",
+	'reqd' => "no",
+	'hiddengli' => "yes" } ];
 
 my $options = { 'name'     => "ConvertToPlug",
@@ -73,48 +83,43 @@
 		'args'     => $arguments };
 
-sub parse_args
+
+sub findType
 {
-    my $class = shift (@_);
-    my ($args) = @_;
-
-    my $plugin_name = $class;
-    $plugin_name =~ s/\.pm$//;
-
-    my $newargs = {};
-
-    if (!parsargv::parse($args,  
-			 q^extract_keyphrases^, \$newargs->{'kea'}, #with extra options (undocumented) 
-			 q^extract_keyphrase_options/.*/^, \$newargs->{'kea_options'}, #no extra options (undocumented)
-			 q^convert_to/(html|text)/html^, \$newargs->{'generate_format'},
-			 q^use_strings^, \$newargs->{'use_strings'},
-			 "allow_extra_options")) {
-
-	print STDERR "\nIncorrect options passed to $plugin_name, ";
-	print STDERR "check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-   
-    return ($plugin_name, $newargs);
+    my ($inputargs) = @_;
+    
+    for(my $intCounter = 0; $intCounter < scalar(@{$inputargs}) ; $intCounter++)
+    {
+	if($inputargs->[$intCounter] eq "-convert_to")
+	{
+	    if($inputargs->[$intCounter+1] eq "text" || $inputargs->[$intCounter+1] eq "html")
+	    {
+		return $inputargs->[$intCounter+1];
+	    }
+	    else {return "html";}
+	}
+    }
+    return "html";
 }
 
 sub new {
-    my $class = shift (@_);
-    if ($class eq "ConvertToPlug" && defined $_[0]) {$class = shift (@_);}
-    my $self;
-    # parsargv::parse might modify the list, so we do this by creating a copy
-    # of the argument list.
-    my @arglist = @_;
-    my ($plugin_name, $args) = $class->parse_args(\@_);
-
-    if ($class eq "PDFPlug" && $args->{'generate_format'} eq "text" && 
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+    my $classPluginName = (defined $pluginlist->[0]) ? $pluginlist->[0] : $class;
+    my $strConvertTo = findType($inputargs);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    if ($classPluginName eq "PDFPlug" && $strConvertTo eq "text" && 
 	$ENV{'GSDLOS'} =~ /^windows$/i) {
 	print STDERR "Windows does not support pdf to text. PDFs will be converted to HTML instead\n";
-	$args->{'generate_format'} = "html";
-    }
-
-    if ($args->{'generate_format'} eq "text")
+	$strConvertTo = "html";
+    }
+
+    my $self = {};
+    if ($strConvertTo eq "text")
     {
-	$self = new TEXTPlug ($class, @arglist);
+	$self = (defined $hashArgOptLists)? new TEXTPlug($pluginlist,$inputargs,$hashArgOptLists): new TEXTPlug($pluginlist,$inputargs);
 	$self->{'convert_to'} = "TEXT";
 	$self->{'convert_to_ext'} = "txt";
@@ -122,5 +127,5 @@
     else
     {
-	$self = new HTMLPlug ($class, @arglist);
+	$self = (defined $hashArgOptLists)? new HTMLPlug($pluginlist,$inputargs,$hashArgOptLists): new HTMLPlug($pluginlist,$inputargs);
 	$self->{'convert_to'} = "HTML";
 	$self->{'convert_to_ext'} = "html";
@@ -130,12 +135,4 @@
     }
 
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    foreach my $key (keys %$args) {
-      $self->{$key} = $args->{$key};
-    }
- 
     return bless $self, $class;
 }
@@ -273,5 +270,5 @@
 
     my $outhandle = $self->{'outhandle'};
-
+    
     my $filename = $file;
     $filename = &util::filename_cat ($base_dir, $file) if $base_dir =~ /\w/;
@@ -296,4 +293,5 @@
 
     my $output_ext = $self->{'convert_to_ext'};
+    
     my $conv_filename = $self->tmp_area_convert_file($output_ext, $filename);
 
Index: /trunk/gsdl/perllib/plugins/ConvertToRogPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/ConvertToRogPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/ConvertToRogPlug.pm	(revision 10218)
@@ -63,19 +63,15 @@
 
 sub new {
-    my $class = shift (@_);
-    if ($class eq "ConvertToRogPlug" && defined $_[0]) {$class = shift (@_);}
-    my $self;
-    # parsargv::parse might modify the list, so we do this by creating a copy
-    # of the argument list.
-    my @arglist = @_;
-    my ($plugin_name) = $class->parse_args(\@_);
-
-    $self = new RogPlug ($class, @arglist);
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new RogPlug($pluginlist,$inputargs,$hashArgOptLists): new RogPlug($pluginlist,$inputargs);
+
     $self->{'convert_to'} = "Rog";
     $self->{'convert_to_ext'} = "rog";
-    $self->{'plugin_type'} = "ConvertToRogPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/DBPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/DBPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/DBPlug.pm	(revision 10218)
@@ -61,16 +61,12 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ($class, @_);
-    $self->{'plugin_type'} = "DBPlug";
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    # no plugin-specific options
-#    if (!parsargv::parse(\@_, "allow_extra_options")) {
-#	$self->print_txt_usage("");  # Use default resource bundle
-#	die "\n";
-#    }
-
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/DSpacePlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/DSpacePlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/DSpacePlug.pm	(revision 10218)
@@ -54,5 +54,5 @@
 
 sub BEGIN {
-    @ISA = ('BasPlug');
+    @DSpacePlug::ISA = ('BasPlug');
 }
 
@@ -96,24 +96,12 @@
 
 sub new {
-    my $class = shift (@_);
-    #my $plugin_name = shift (@_);
-
-    $self = new BasPlug ($class, @_);
-    $self->{'plugin_type'} = "DSpacePlug";
-
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
- 
-    if (!parsargv::parse(\@_,
-			 q^only_first_doc^, \$self->{'only_first_doc'},
-			 q^first_inorder_ext/.*/^, \$self->{'first_inorder_ext'},
-			 q^first_inorder_mime/.*/^, \$self->{'first_inorder_mime'},
-			 "allow_extra_options")) {
-	print STDERR "\nDSpacePlug uses an incorrect option.\n";
-	print STDERR "Check your collect.cfg configuration file.\n\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
+    my ($class) = shift (@_); 
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
     
     #create XML::Parser object for parsing dublin_core.xml files
Index: /trunk/gsdl/perllib/plugins/EMAILPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/EMAILPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/EMAILPlug.pm	(revision 10218)
@@ -113,21 +113,13 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ($class, @_);
-    $self->{'plugin_type'} = "EMAILPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if (!parsargv::parse(\@_, 
-			 q^split_exp/.*/^, \$self->{'split_exp'},
-			 q^no_attachments^, \$self->{'ignore_attachments'},
-			 q^headers^, \$self->{'header_metadata'},
-			 "allow_extra_options")) {
-	print STDERR "\nIncorrect options passed to $class.";
-	print STDERR "\nCheck your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new SplitPlug($pluginlist,$inputargs,$hashArgOptLists): new SplitPlug($pluginlist,$inputargs);
+
     $self->{'assoc_filenames'} = {}; # to save attach names so we don't clobber
 
@@ -431,5 +423,5 @@
 
     
-    if ($self->{'header_metadata'} && $self->{'header_metadata'} == 1) {
+    if ($self->{'headers'} && $self->{'headers'} == 1) {
 	# Add "All headers" metadata
 	$Headers = &text_into_html($Headers);
@@ -791,5 +783,5 @@
 	
 	# save attachment by default
-	if (!$self->{'ignore_attachments'}
+	if (!$self->{'no_attachments'}
 	    && $filename ne "") { # this part has a file...
 	    my $encoding="8bit";
Index: /trunk/gsdl/perllib/plugins/ExcelPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/ExcelPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/ExcelPlug.pm	(revision 10218)
@@ -49,18 +49,12 @@
 
 sub new {
-    my $class = shift (@_);
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
 
-    my $self = new ConvertToPlug ($class, @_);
-    $self->{'plugin_type'} = "ExcelPlug";
-# I'm not sure what encoding xlhtml produces - I think it puts it
-# into the Content-Type meta tag in the header of the HTML file.
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
 
-#    if ($self->{'input_encoding'} eq "auto") {
-#	$self->{'input_encoding'} = "utf8";
-#    }
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my $self = (defined $hashArgOptLists)? new ConvertToPlug($pluginlist,$inputargs,$hashArgOptLists): new ConvertToPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/FOXPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/FOXPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/FOXPlug.pm	(revision 10218)
@@ -51,10 +51,12 @@
 
 sub new {
-    my ($class) = @_;
-    $self = new BasPlug ();
-    $self->{'plugin_type'} = "FOXPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/FavouritesPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/FavouritesPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/FavouritesPlug.pm	(revision 10218)
@@ -34,5 +34,5 @@
 
 sub BEGIN {
-    @ISA = ('BasPlug');
+    @FavouritesPlug::ISA = ('BasPlug');
 }
 
@@ -52,11 +52,12 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ($class, @_);
-    $self->{'plugin_type'} = "FavouritesPlug";
+    my ($class) = shift(@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
 
-    # To allow for proper inheritance of arguments
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/GAPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/GAPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/GAPlug.pm	(revision 10218)
@@ -32,4 +32,6 @@
 
 use XMLPlug;
+#$%^
+use parse2;
 
 sub BEGIN {
@@ -50,10 +52,12 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new XMLPlug ($class, @_);
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
 
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new XMLPlug($pluginlist,$inputargs,$hashArgOptLists): new XMLPlug($pluginlist,$inputargs);
 
     $self->{'section'} = "";
Index: /trunk/gsdl/perllib/plugins/GMLPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/GMLPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/GMLPlug.pm	(revision 10218)
@@ -53,12 +53,15 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ("GMLPlug", @_);
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    return bless $self, $class;}
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
+
+    return bless $self, $class;
+}
 
 sub get_default_process_exp {
Index: /trunk/gsdl/perllib/plugins/HBPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/HBPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/HBPlug.pm	(revision 10218)
@@ -68,10 +68,12 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ("HBPlug", @_);
-    $self->{'plugin_type'} = "HBPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/HTMLPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/HTMLPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/HTMLPlug.pm	(revision 10218)
@@ -92,4 +92,10 @@
 	'desc' => "{HTMLPlug.description_tags}",
 	'type' => "flag" },
+      # retain this for backward compatibility (w3mir option was replaced by
+      # file_is_url)
+      { 'name' => "w3mir",
+#	'desc' => "{HTMLPlug.w3mir}",
+	'type' => "flag",
+	'hiddengli' => "yes"},
       { 'name' => "no_strip_metadata_html",
 	'desc' => "{HTMLPlug.no_strip_metadata_html}",
@@ -109,34 +115,13 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new BasPlug ($class, @_);
-    $self->{'plugin_type'} = "HTMLPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-    
-    if (!parsargv::parse(\@_, 
-			 q^nolinks^, \$self->{'nolinks'},
-			 q^keep_head^, \$self->{'keep_head'},
-			 q^no_metadata^, \$self->{'no_metadata'},
-			 q^metadata_fields/.*/Title^, \$self->{'metadata_fields'},
-			 q^hunt_creator_metadata^, \$self->{'hunt_creator_metadata'},
-			 q^w3mir^, \$self->{'w3mir'},
-			 q^file_is_url^, \$self->{'file_is_url'},
-			 q^assoc_files/.*/(?i)\.(jpe?g|jpe|gif|png|css)$^, \$self->{'assoc_files'},
-			 q^rename_assoc_files^, \$self->{'rename_assoc_files'},
-			 q^title_sub/.*/^, \$self->{'title_sub'},
-			 q^description_tags^, \$self->{'description_tags'},
-			 q^no_strip_metadata_html/.*/^, \$self->{'no_strip_metadata_html'},
-			 q^sectionalise_using_h_tags^, \$self->{'sectionalise_using_h_tags'},
-			 "allow_extra_options")) {
-
-	print STDERR "\nIncorrect options passed to HTMLPlug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-
-    # retain this for backward compatibility (w3mir option was replaced by
-    # file_is_url)
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
+
     if ($self->{'w3mir'}) {
 	$self->{'file_is_url'} = 1;
@@ -146,5 +131,5 @@
     $self->{'dir_num'} = 0;
     $self->{'file_num'} = 0;
-
+    
     return bless $self, $class;
 }
Index: /trunk/gsdl/perllib/plugins/ISISPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/ISISPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/ISISPlug.pm	(revision 10218)
@@ -96,19 +96,12 @@
 sub new
 {
-    my $class = shift(@_);
-
-    my $self = new SplitPlug($class, @_);
-    if (!parsargv::parse(\@_, 
-			 q^subfield_separator/.*/, ^, \$self->{'subfield_separator'},
-			 q^entry_separator/.*/<br>^, \$self->{'entry_separator'},
-			 "allow_extra_options")) {
-	print STDERR "\nIncorrect options passed to ISISPlug, check your collect.cfg configuration file\n";
-	die "\n";
-    }
-
-    # To allow for proper inheritance of arguments
-    my $option_list = $self->{'option_list'};
-    push(@{$option_list}, $options);
-    $self->{'plugin_type'} = "ISISPlug";
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new SplitPlug($pluginlist,$inputargs,$hashArgOptLists): new SplitPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
